package sample.jsf;

import java.util.ArrayList;

import javax.faces.event.ActionEvent;
import javax.faces.model.SelectItem;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.transaction.UserTransaction;

public class Employee {
	public int empNo;
	public String empName;
	public String deptName;
	public String sex;
	public double salary;
	public String band;
	ArrayList<SelectItem> deptOptions;
	
    @PersistenceContext    
    private EntityManager em;
	 
	public Employee(){
		
		deptOptions = new ArrayList<SelectItem>();
		
		SelectItem option = new SelectItem("Inventory", "Inventory");
		deptOptions.add(option);
		
		option = new SelectItem("Production", "Production");
		deptOptions.add(option);
		
		option = new SelectItem("Accounts", "Accounts");
		deptOptions.add(option);
		
		option = new SelectItem("Finance", "Finance");
		deptOptions.add(option);
		
		option = new SelectItem("Marketing", "Marketing");
		deptOptions.add(option);
		
		option = new SelectItem("IncomeTax", "IncomeTax");
		deptOptions.add(option);
		
		option = new SelectItem("Engineering", "Engineering");
		deptOptions.add(option);
		
	}
	
	public int getEmpNo() {
		return empNo;
	}
	public void setEmpNo(int empNo) {
		this.empNo = empNo;
	}
	public String getEmpName() {
		return empName;
	}
	public void setEmpName(String empName) {
		this.empName = empName;
	}
	public String getDeptName() {
		return deptName;
	}
	public void setDeptName(String deptName) {
		this.deptName = deptName;
	}
	public String getSex() {
		return sex;
	}
	public void setSex(String sex) {
		this.sex = sex;
	}
	public double getSalary() {
		return salary;
	}
	public void setSalary(double salary) {
		this.salary = salary;
	}
	public String getBand() {
		return band;
	}
	public void setBand(String band) {
		this.band = band;
	}
	
	public void addEmployee(ActionEvent event){
		
		com.jpa.sample.Employee employeeDup = em.find(com.jpa.sample.Employee.class, this.empNo);
		if(employeeDup != null)
			throw new IllegalArgumentException("Message : sample.jsf.Employee : Employee Already Exits ("+this.empNo+")");
		
		com.jpa.sample.Employee employee = new com.jpa.sample.Employee();
		
		employee.setBand(this.band);
		employee.setDeptName(this.deptName);
		employee.setEmpName(this.empName);
		employee.setEmpNo(this.empNo);
		employee.setSalary(this.salary);
		employee.setSex(this.sex);
		
		try{
			
			Context ctx = new InitialContext();
			UserTransaction ut = (UserTransaction)ctx.lookup("java:comp/UserTransaction");
			ut.begin();
			em.persist(employee);
			ut.commit();
			
		}catch (Exception e){
			throw new IllegalArgumentException("Message : sample.jsf.Employee : Exception :"+e);
		}

		
	}

	public void editEmployee(ActionEvent event){
	
		try{
			
			Context ctx = new InitialContext();
			UserTransaction ut = (UserTransaction)ctx.lookup("java:comp/UserTransaction");
			ut.begin();
			com.jpa.sample.Employee employee = em.find(com.jpa.sample.Employee.class, this.empNo);
			employee.setBand(this.band);
			employee.setDeptName(this.deptName);
			employee.setEmpName(this.empName);
			employee.setEmpNo(this.empNo);
			employee.setSalary(this.salary);
			employee.setSex(this.sex);
			ut.commit();
		}catch (Exception e){
			throw new IllegalArgumentException("Message : sample.jsf.Employee : Exception :"+e);
		}

		
	}
	public ArrayList<SelectItem> getDeptOptions() {
		return deptOptions;
	}

	public void setDeptOptions(ArrayList<SelectItem> deptOptions) {
		this.deptOptions = deptOptions;
	}
	
	public void retrieveEmployee(ActionEvent event){
		com.jpa.sample.Employee employeeDup = em.find(com.jpa.sample.Employee.class, this.empNo);
		if(employeeDup == null)
			throw new IllegalArgumentException("Message : sample.jsf.Employee : Employee does not exit ("+this.empNo+")");
		
		this.setBand(employeeDup.getBand());
		this.setDeptName(employeeDup.getDeptName());
		this.setEmpName(employeeDup.getEmpName());
		this.setEmpNo(employeeDup.getEmpNo());
		this.setSalary(employeeDup.getSalary());
		this.setSex(employeeDup.getSex());
		
	}
	
}
